TestCase subclass: #CardapioIngredientesTest
	instanceVariableNames: 'listaDeIngredientes carding pao queijo carne sucoLaranja gelo tomate cebola alface'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fase2-Tests'!

!CardapioIngredientesTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 00:44'!
setUp
	
	pao := Ingrediente novo:'Pao' precoDe:1 comCalorias:40.
	queijo := Ingrediente novo:'Queijo' precoDe:3 comCalorias:65.
	carne := Ingrediente novo:'Carne' precoDe:5 comCalorias:92.
	sucoLaranja:= Ingrediente novo:'Suco de Laranja' precoDe:3 comCalorias:12.
	gelo:= Ingrediente novo:'Gelo' precoDe:0 comCalorias:0.
	tomate:= Ingrediente novo:'Tomate' precoDe:1.15 comCalorias:15.
	cebola:= Ingrediente novo:'Cebola' precoDe:0.75 comCalorias:10.
	alface:= Ingrediente novo:'Alface' precoDe:2.3 comCalorias:1.
	
	carding := CardapioIngredientes resetInstance.
	"carding := CardapioIngredientes getInstance."
	carding adiciona:pao; adiciona:queijo; adiciona:tomate.
! !

!CardapioIngredientesTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 17:58'!
testAdiciona
	
	| listaIngr |
	carding adiciona: carne.
	
	listaIngr := carding listaDeIngredientes.
	self deny: (listaIngr size = 3).
	self assert: (listaIngr size = 4).
	
	self assert: ( (listaIngr at:1) = pao).
	self assert: ( (listaIngr at:2) = queijo).
	self assert: ( (listaIngr at:3) = tomate).
	self assert: ( (listaIngr at:4) = carne).
! !

!CardapioIngredientesTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 17:57'!
testListaDeIngredientes
	
	| listaIngr |
	listaIngr := carding listaDeIngredientes.
	self assert: (listaIngr size = 3).
	
	self assert: ( (listaIngr at:1) = pao).
	self assert: ( (listaIngr at:2) = queijo).
	self assert: ( (listaIngr at:3) = tomate).
! !

!CardapioIngredientesTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 18:00'!
testRemove
	
	| listaIngr |
	carding remove: pao.
	
	listaIngr := carding listaDeIngredientes.
	self deny: (listaIngr size = 3).
	self assert: (listaIngr size = 2).
	
	self deny: ( (listaIngr at:1) = pao).
	self deny: ( (listaIngr at:2) = queijo).
	
	self assert: ( (listaIngr at:1) = queijo).
	self assert: ( (listaIngr at:2) = tomate).
! !


TestCase subclass: #CardapioTest
	instanceVariableNames: 'card xBurguer sucoDeLaranja salada xSalada lanche duplo pao queijo carne sucoLaranja gelo tomate cebola alface'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fase2-Tests'!

!CardapioTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:59'!
setUp
	
	| listaIngr listaPratos |
	
	pao := Ingrediente novo:'Pao' precoDe:1 comCalorias:40.
	queijo := Ingrediente novo:'Queijo' precoDe:3 comCalorias:65.
	carne := Ingrediente novo:'Carne' precoDe:5 comCalorias:92.
	sucoLaranja:= Ingrediente novo:'Suco de Laranja' precoDe:3 comCalorias:12.
	gelo:= Ingrediente novo:'Gelo' precoDe:0 comCalorias:0.
	tomate:= Ingrediente novo:'Tomate' precoDe:1.15 comCalorias:15.
	cebola:= Ingrediente novo:'Cebola' precoDe:0.75 comCalorias:10.
	alface:= Ingrediente novo:'Alface' precoDe:2.3 comCalorias:1.
	
	listaIngr := OrderedCollection new.
	listaIngr add:pao; add:queijo; add:carne.
	xBurguer := 
Prato novo:'XBurguer' comPreco: 10 feitoDe: listaIngr.
	
	listaIngr := OrderedCollection new.
	listaIngr add:sucoLaranja; add:gelo.
	sucoDeLaranja := Prato novo: 'Suco de Laranja' comPreco:3 feitoDe:listaIngr.
	
	listaIngr := OrderedCollection new.
	listaIngr add:alface; add:tomate; add:cebola.
	salada := Prato novo: 'Salada' comPreco:7.5 feitoDe:listaIngr.
	
	listaIngr := OrderedCollection new.
	listaIngr add:pao; add:queijo; add:tomate; add:cebola; add:alface.
	xSalada := Prato novo: 'XSalada' comPreco:7.5 feitoDe:listaIngr.
	
	listaPratos := OrderedCollection new.
	listaPratos add:xBurguer; add:sucoDeLaranja.
	lanche := Combinado novo:'Lanche 1' compostoDe:listaPratos comPreco:11.
	
	listaPratos := OrderedCollection new.
	listaPratos add:xBurguer; add:sucoDeLaranja; add:xSalada; add:sucoDeLaranja.
	duplo := Combinado novo:'Duplo' compostoDe:listaPratos comPreco:20.
	
	card := Cardapio getInstance.
	card := Cardapio resetInstance.
	card adicionaPrato:xBurguer; adicionaPrato:sucoDeLaranja; adicionaPrato:xSalada.
	
	card adicionaCombinado:lanche.
! !

!CardapioTest methodsFor: 'as yet unclassified' stamp: 'idl 6/9/2007 22:36'!
testAdiciona
	menu adicionaPrato:xBurguer.
	listaPratos := menu listaDePratos.
	self deny: ( (listaPratos indexOf:xBurguer) = 0 ).
! !

!CardapioTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 21:29'!
testAdicionaCombinado
	
	| listaCombinados |
	card adicionaCombinado:duplo.
	listaCombinados := card listaDeCombinadosDesativados.
	self deny: (listaCombinados size = 1).
	self assert: (listaCombinados size = 2).
! !

!CardapioTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:53'!
testAdicionaPrato
	
	| listaPratos |
	card adicionaPrato:salada.
	listaPratos := card listaDePratos.
	self deny: (listaPratos size = 3).
	self assert: (listaPratos size = 4).
! !

!CardapioTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 20:47'!
testAtiva
	
	| listaComb |
	card ativa:lanche.
	
	self deny: (card listaDeCombinadosDesativados size = 1).
	self assert: (card listaDeCombinadosDesativados size = 0).
	
	listaComb := card listaDeCombinados.
	self deny: (listaComb size = 0).
	self assert: (listaComb size = 1).
	self assert: ( (listaComb at:1) = lanche).
! !

!CardapioTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 20:46'!
testDesativa
	
	| listaComb |
	card ativa:lanche.
	card desativa:lanche.
	
	self deny: (card listaDeCombinados size = 1).
	self assert: (card listaDeCombinados size = 0).
	
	listaComb := card listaDeCombinadosDesativados.
	self deny: (listaComb size = 0).
	self assert: (listaComb size = 1).
	self assert: ( (listaComb at:1) = lanche).
! !

!CardapioTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 20:54'!
testListaDeCombinados
	
	| listaComb |
	self assert: (card listaDeCombinados size = 0).
	
	card ativa: lanche.
	
	listaComb := card listaDeCombinados.
	self deny: (listaComb size = 0).
	self assert: (listaComb size = 1).
	self assert: ( (listaComb at:1) = lanche).
! !

!CardapioTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 20:53'!
testListaDeCombinadosDesativados
	
	| listaComb |
	listaComb := card listaDeCombinadosDesativados.
	self assert: (listaComb size = 1).
	self assert: ( (listaComb at:1) = lanche).
! !

!CardapioTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 20:56'!
testListaDePratos
	
	| listaPratos |
	listaPratos := card listaDePratos.
	self assert: (listaPratos size = 3).
	self assert: ( (listaPratos at:1) = xBurguer).
	self assert: ( (listaPratos at:2) = sucoDeLaranja).
	self assert: ( (listaPratos at:3) = xSalada).
! !

!CardapioTest methodsFor: 'as yet unclassified' stamp: 'idl 6/9/2007 23:42'!
testRemove
	menu adicionaPrato:xBurguer.
	menu adicionaPrato:salada.
	listaPratos := menu listaDePratos.
	self deny: ( (listaPratos indexOf:salada) = 0 ).
	menu remove: salada.
	listaPratos := menu listaDePratos.
	self assert: ( (listaPratos indexOf:salada) = 0 ).
! !

!CardapioTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 21:02'!
testRemoveCombinado
	
	card ativa:lanche.
	card removeCombinado: lanche.
	
	self deny: (card listaDeCombinados size = 1).
	self assert: (card listaDeCombinados size = 0).
! !

!CardapioTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 21:02'!
testRemoveCombinadoDesativado
	
	card removeCombinadoDesativado: lanche.
	
	self deny: (card listaDeCombinadosDesativados size = 1).
	self assert: (card listaDeCombinadosDesativados size = 0).
! !

!CardapioTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:55'!
testRemovePrato
	
	| listaPratos |
	card removePrato: sucoDeLaranja.
	
	listaPratos := card listaDePratos.
	self deny: (listaPratos size = 3).
	self assert: (listaPratos size = 2).
	
	self assert: ( (listaPratos at:1) = xBurguer).
	self assert: ( (listaPratos at:2) = xSalada).
! !


TestCase subclass: #CombinadoTest
	instanceVariableNames: 'listaDePratos xBurguer sucoDeLaranja salada combinado nomeCombinado precoCombinado caloriasCombinado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fase2-Tests'!

!CombinadoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 00:52'!
setUp
	
	| listaIngrXBurguer listaIngrSuco listaIngrSalada
	pao queijo carne sucoLaranja gelo tomate cebola alface |
	
	pao := Ingrediente novo:'Pao' precoDe:1 comCalorias:40.
	queijo := Ingrediente novo:'Queijo' precoDe:3 comCalorias:65.
	carne := Ingrediente novo:'Carne' precoDe:5 comCalorias:92.
	sucoLaranja:= Ingrediente novo:'Suco de Laranja' precoDe:3 comCalorias:12.
	gelo:= Ingrediente novo:'Gelo' precoDe:0 comCalorias:0.
	tomate:= Ingrediente novo:'Tomate' precoDe:1.15 comCalorias:15.
	cebola:= Ingrediente novo:'Cebola' precoDe:0.75 comCalorias:10.
	alface:= Ingrediente novo:'Alface' precoDe:2.3 comCalorias:1.
	
	listaIngrXBurguer := OrderedCollection new.
	listaIngrXBurguer add:pao; add:queijo; add:carne.
	
	listaIngrSuco := OrderedCollection new.
	listaIngrSuco add:sucoLaranja; add:gelo.
	
	listaIngrSalada := OrderedCollection new.
	listaIngrSalada add:alface; add:tomate; add:cebola.
	
	xBurguer := 
Prato novo:'XBurguer' comPreco:10 feitoDe: listaIngrXBurguer.
	sucoDeLaranja := Prato novo:'Suco de Laranja' comPreco:3 feitoDe:listaIngrSuco.
	salada := Prato novo:'Salada' comPreco:7.5 feitoDe:listaIngrSalada.
	
	listaDePratos := OrderedCollection new.
	listaDePratos add:xBurguer; add:sucoDeLaranja.
	caloriasCombinado := 209.
	
	nomeCombinado:= 'Lanche 1'.
	precoCombinado:= 11.
	combinado := Combinado novo:nomeCombinado compostoDe:listaDePratos comPreco:precoCombinado.
! !

!CombinadoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 18:56'!
testAddPrato
	
	| listaPratos |
	combinado addPrato:salada.
	listaPratos := combinado pratos.
	
	self deny: (listaPratos size = 2).
	self assert: (listaPratos size = 3).
	
	self assert: ( (listaPratos at:1) = xBurguer).
	self assert: ( (listaPratos at:2) = sucoDeLaranja).
	self assert: ( (listaPratos at:3) = salada).
! !

!CombinadoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 00:53'!
testAtivado
	
	self assert: (combinado ativado = false).
! !

!CombinadoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 00:53'!
testAtivar
	
	combinado ativar.
	self deny: (combinado ativado = false).
	self assert: (combinado ativado = true).
! !

!CombinadoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 19:21'!
testAtualizaCalorias
	
	| caloriasAntigas caloriasNovas |
	caloriasAntigas := combinado calorias.
	combinado addPrato: salada.
	combinado AtualizaCalorias.
	caloriasNovas:= combinado calorias.
	self deny: (caloriasNovas = caloriasAntigas).
	self assert: (caloriasNovas = (caloriasAntigas + salada calorias) ).
! !

!CombinadoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 18:45'!
testCalorias
	
	self assert: (combinado calorias = caloriasCombinado).
! !

!CombinadoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 18:44'!
testDesativar
	
	combinado ativar.
	combinado desativar.
	self deny: (combinado ativado = true).
	self assert: (combinado ativado = false).
! !

!CombinadoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 19:22'!
testGetCalorias
	
	| caloriasAntigas caloriasNovas |
	caloriasAntigas := combinado calorias.
	combinado addPrato: salada.
	caloriasNovas:= combinado getCalorias.
	self deny: (caloriasNovas = caloriasAntigas).
	self assert: (caloriasNovas = (caloriasAntigas + salada calorias) ).
! !

!CombinadoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 18:58'!
testGetPreco
	
	self assert: (xBurguer preco + sucoDeLaranja preco = combinado getPreco).
! !

!CombinadoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 19:09'!
testListaDePratos
	
	| listaPratos |
	listaPratos:= OrderedCollection new.
	listaPratos add:sucoDeLaranja; add:salada; add:xBurguer.
	combinado listaDePratos: listaPratos.
	
	listaPratos := combinado pratos.
	self deny: (listaPratos size = 2).
	self assert: (listaPratos size = 3).
	
	self deny: ( (listaPratos at:1) = xBurguer).
	self deny: ( (listaPratos at:2) = sucoDeLaranja).
	
	self assert: ( (listaPratos at:1) = sucoDeLaranja).
	self assert: ( (listaPratos at:2) = salada).
	self assert: ( (listaPratos at:3) = xBurguer).
! !

!CombinadoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 19:10'!
testPratos
	
	| listaPratos |
	listaPratos := combinado pratos.
	self assert: (listaPratos size = 2).
	
	self assert: ( (listaPratos at:1) = xBurguer).
	self assert: ( (listaPratos at:2) = sucoDeLaranja).
! !

!CombinadoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 19:13'!
testPreco
	
	| novoPreco |
	novoPreco := 29.
	self assert: (combinado preco = precoCombinado).
	
	combinado preco: novoPreco.
	self deny: (combinado preco = precoCombinado).
	self assert: (combinado preco = novoPreco).
! !

!CombinadoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 19:15'!
testRemovePrato
	
	| listaPratos |
	combinado removePrato: xBurguer.
	listaPratos := combinado pratos.
	
	self deny: (listaPratos size = 2).
	self assert: (listaPratos size = 1).
	
	self deny: ( (listaPratos at:1) = xBurguer).
	self assert: ( (listaPratos at:1) = sucoDeLaranja).
! !


TestCase subclass: #GeradoraDeCupomTest
	instanceVariableNames: 'geradora'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fase2-Tests'!

!GeradoraDeCupomTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 04:45'!
setUp
	
	geradora := GeradoraDeCupom getInstance.
! !

!GeradoraDeCupomTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 05:03'!
testDesconto
	
	| desc |
	desc := geradora desconto:30.
	self assert: (desc = 10).
	
	desc := geradora desconto:20.
	self assert: (desc = 5).
	
	desc := geradora desconto:9.
	self assert: (desc = 0).
! !

!GeradoraDeCupomTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 05:22'!
testGerenciamentoRegistrosDesc
	"nao seria possivel testar isoladamente consultaDesconto: e geraRegistroDesc:valor: de maneira adequada pois, para testar qualquer uma das duas a outra tem que ser empregada e simultaneamente testada. Testam-se aqui, portanto, os dois metodos juntos."
	
	| desc1 desc2 cpf1 cpf2 consulta |
	cpf1 := 12345678900.
	desc1 := geradora geraRegistroDesc: cpf1 valor:50.
	self assert: (desc1 = 10).
	
	cpf2 := 98765432100.
	desc2 := geradora geraRegistroDesc: cpf2 valor:18.
	self assert: (desc2 = 5).
	
	consulta := (geradora consultaDesconto: cpf1).
	self assert: (consulta = (desc1 asFloat*0.01) ).
	
	consulta := (geradora consultaDesconto: cpf2).
	self assert: (consulta = (desc2 asFloat*0.01) ).
	
	consulta := geradora consultaDesconto: 000.
	self assert: (consulta = 0).
! !


TestCase subclass: #IngredienteTest
	instanceVariableNames: 'bacon nome preco calorias'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fase2-Tests'!

!IngredienteTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 14:05'!
setUp
	"Cria um ingrediente e seta seus valores"
	
	bacon:= Ingrediente novo: 'bacon' precoDe:5.3 comCalorias:100.
! !

!IngredienteTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:08'!
testCalorias
	"testa se o no. de calorias eh o esperado"
	
	self assert: (bacon calorias = 100).
	bacon calorias:130.
	self deny: (bacon calorias = 100).
	self assert: (bacon calorias = 130).
! !

!IngredienteTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:08'!
testNome
	"testa se o nome do ingrediente eh o esperado"
	
	self assert: (bacon nome = 'bacon').
	bacon nome: 'toicinho'.
	self deny: (bacon nome = 'bacon').
	self assert: (bacon nome = 'toicinho').
! !

!IngredienteTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:08'!
testPreco
	"testa se o preco do ingrediente eh o esperado"
	
	self assert: (bacon preco = 5.3).
	bacon preco:19.43.
	self deny: (bacon preco = 5.3).
	self assert: (bacon preco = 19.43).
! !


TestCase subclass: #ItemDoCardapioTest
	instanceVariableNames: 'xBurguer sucoDeLaranja salada combinado nomeXBurguer nomeCombinado precoXBurguer precoCombinado caloriasXBurguer caloriasCombinado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fase2-Tests'!

!ItemDoCardapioTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:12'!
setUp
	"inicializa variveis de instancia"
	
	| listaIngrXBurguer listaIngrSuco listaIngrSalada listaPratos
	pao queijo carne sucoLaranja gelo tomate cebola alface |
	
	pao := Ingrediente novo:'Pao' precoDe:1 comCalorias:40.
	queijo := Ingrediente novo:'Queijo' precoDe:3 comCalorias:65.
	carne := Ingrediente novo:'Carne' precoDe:5 comCalorias:92.
	sucoLaranja:= Ingrediente novo:'Suco de Laranja' precoDe:3 comCalorias:12.
	gelo:= Ingrediente novo:'Gelo' precoDe:0 comCalorias:0.
	tomate:= Ingrediente novo:'Tomate' precoDe:1.15 comCalorias:15.
	cebola:= Ingrediente novo:'Cebola' precoDe:0.75 comCalorias:10.
	alface:= Ingrediente novo:'Alface' precoDe:2.3 comCalorias:1.
	
	listaIngrXBurguer := OrderedCollection new.
	listaIngrXBurguer add:pao; add:queijo; add:carne.
	caloriasXBurguer := 197.
	
	listaIngrSuco := OrderedCollection new.
	listaIngrSuco add:sucoLaranja; add:gelo.
	
	listaIngrSalada := OrderedCollection new.
	listaIngrSalada add:alface; add:tomate; add:cebola.
	
	nomeXBurguer:= 'XBurguer'.
	precoXBurguer:= 10.
	xBurguer := 
Prato novo: nomeXBurguer comPreco:precoXBurguer feitoDe: listaIngrXBurguer.
	sucoDeLaranja := Prato novo: 'Suco de Laranja' comPreco:3 feitoDe:listaIngrSuco.
	salada := Prato novo: 'Salada' comPreco:7.5 feitoDe:listaIngrSalada.
	
	listaPratos := OrderedCollection new.
	listaPratos add:xBurguer; add:sucoDeLaranja.
	caloriasCombinado := 209.
	
	nomeCombinado:= 'Lanche 1'.
	precoCombinado:= 11.
	combinado := Combinado novo:nomeCombinado compostoDe:listaPratos comPreco:precoCombinado.
! !

!ItemDoCardapioTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 17:02'!
testCalorias
	
	self assert: (xBurguer calorias = caloriasXBurguer).
	self assert: (combinado calorias = caloriasCombinado).
! !

!ItemDoCardapioTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 17:10'!
testNome
	
	self assert: (xBurguer nome = nomeXBurguer).
	self assert: (combinado nome = nomeCombinado).
	
	xBurguer nome:'Sandubao'.
	combinado nome:'Merenda'.
	
	self deny: (xBurguer nome = nomeXBurguer).
	self deny: (combinado nome = nomeCombinado).
	self assert: (xBurguer nome = 'Sandubao').
	self assert: (combinado nome = 'Merenda').
! !

!ItemDoCardapioTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 17:11'!
testPreco
	
	self assert: (xBurguer preco = precoXBurguer).
	self assert: (combinado preco = precoCombinado).
! !


TestCase subclass: #PedidoTest
	instanceVariableNames: 'pedido xBurguer sucoDeLaranja salada xSalada lanche duplo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fase2-Tests'!

!PedidoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 07:24'!
setUp
	"inicializa variveis de instancia"
	
	| listaIngr listaPratos
	pao queijo carne sucoLaranja gelo tomate cebola alface |
	
	pao := Ingrediente novo:'Pao' precoDe:1 comCalorias:40.
	queijo := Ingrediente novo:'Queijo' precoDe:3 comCalorias:65.
	carne := Ingrediente novo:'Carne' precoDe:5 comCalorias:92.
	sucoLaranja:= Ingrediente novo:'Suco de Laranja' precoDe:3 comCalorias:12.
	gelo:= Ingrediente novo:'Gelo' precoDe:0 comCalorias:0.
	tomate:= Ingrediente novo:'Tomate' precoDe:1.15 comCalorias:15.
	cebola:= Ingrediente novo:'Cebola' precoDe:0.75 comCalorias:10.
	alface:= Ingrediente novo:'Alface' precoDe:2.3 comCalorias:1.
	
	listaIngr := OrderedCollection new.
	listaIngr add:pao; add:queijo; add:carne.
	xBurguer := 
Prato novo: 'XBurguer' comPreco:10 feitoDe: listaIngr.
	
	listaIngr := OrderedCollection new.
	listaIngr add:sucoLaranja; add:gelo.
	sucoDeLaranja := Prato novo: 'Suco de Laranja' comPreco:3 feitoDe:listaIngr.
	
	listaIngr := OrderedCollection new.
	listaIngr add:alface; add:tomate; add:cebola.
	salada := Prato novo: 'Salada' comPreco:7.5 feitoDe:listaIngr.
	
	listaIngr := OrderedCollection new.
	listaIngr add:pao; add:queijo; add:tomate; add:cebola; add:alface.
	xSalada := Prato novo: 'XSalada' comPreco:7.5 feitoDe:listaIngr.
	
	listaPratos := OrderedCollection new.
	listaPratos add:xBurguer; add:sucoDeLaranja.
	lanche := Combinado novo:'Lanche 1' compostoDe:listaPratos comPreco:11.
	
	listaPratos := OrderedCollection new.
	listaPratos add:xBurguer; add:sucoDeLaranja; add:xSalada; add:sucoDeLaranja.
	duplo := Combinado novo:'Duplo' compostoDe:listaPratos comPreco:20.

	pedido:= Pedido new.

	pedido adiciona:xBurguer; adiciona:sucoDeLaranja.
	
	pedido adiciona:lanche.
	
	pedido adiciona:xSalada.
! !

!PedidoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 07:24'!
testAdiciona
	
	| listaItensCard |
	pedido adiciona: salada.
	listaItensCard := pedido listaDePratos.
	self deny: (listaItensCard size = 4).
	self assert: (listaItensCard size = 5).
	self assert: ( (listaItensCard at:5) = salada).
	
	pedido adiciona: duplo.
	listaItensCard := pedido listaDePratos.
	self deny: (listaItensCard size = 5).
	self assert: (listaItensCard size = 6).
	self assert: ( (listaItensCard at:6) = duplo).
! !

!PedidoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 07:20'!
testCliente
	"Testa gets e sets de umCliente."
	
	| cliente cliente2 |
	self assert: (pedido getNomeCliente = nil).
	
	cliente := 'Chico Bento'.
	pedido setCliente: cliente.
	self deny: (pedido getNomeCliente = nil).
	self assert: (pedido getNomeCliente = cliente).
	
	cliente2 := 'Penadinho'.
	pedido umCliente: cliente2.
	self deny: (pedido getNomeCliente = cliente).
	self assert: (pedido getNomeCliente = cliente2).
! !

!PedidoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 07:25'!
testCpf
	
	| umCpf |
	self assert: (pedido cpf = nil).
	
	umCpf:= 98765432100.
	pedido cpf: umCpf.
	self deny: (pedido cpf = nil).
	self assert: (pedido cpf = umCpf).
! !

!PedidoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 06:54'!
testDesconto
	
	| desc |
	self assert: (pedido desconto = nil).
	
	desc := 10.
	pedido desconto: desc.
	self deny: (pedido desconto = nil).
	self assert: (pedido desconto = desc).
! !

!PedidoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 07:12'!
testFecharPedido
	
	| precoSomado quantiaDada troco |
	precoSomado := xBurguer preco + sucoDeLaranja preco + lanche preco + xSalada preco.
	quantiaDada := precoSomado + 42.
	troco := pedido fecharPedido: quantiaDada.
	self assert: (troco = 42).
! !

!PedidoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 07:14'!
testGetCalorias
	
	| calSomadas |
	calSomadas := xBurguer calorias + sucoDeLaranja calorias + lanche calorias + xSalada calorias.
	self assert: (pedido getCalorias = calSomadas).
! !

!PedidoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 06:59'!
testLimparPedido
	
	pedido limparPedido.
	self assert: (pedido listaDePratos size = 0).
! !

!PedidoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 06:29'!
testListaDePratos
	
	| listaItensCard |
	listaItensCard := pedido listaDePratos.
	self assert: (listaItensCard size = 4).

	self assert: ( (listaItensCard at:1) = xBurguer).
	self assert: ( (listaItensCard at:2) = sucoDeLaranja).
	self assert: ( (listaItensCard at:3) = lanche).
	self assert: ( (listaItensCard at:4) = xSalada).
! !

!PedidoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 06:49'!
testMaxCalorias
	
	| max |
	self assert: (pedido maxCalorias = nil).
	
	max := 2000.
	pedido maxCalorias: max.
	self deny: (pedido maxCalorias = nil).
	self assert: (pedido maxCalorias = max).
! !

!PedidoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 06:47'!
testPrecoAtual
	
	| precoSomado |
	precoSomado := xBurguer preco + sucoDeLaranja preco + lanche preco + xSalada preco.
	self assert: (pedido precoAtual = precoSomado).
! !

!PedidoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 07:26'!
testRemovePrato
	
	| listaItensCard |
	
	pedido removePrato: xBurguer.
	listaItensCard := pedido listaDePratos.
	self deny: (listaItensCard size = 4).
	self assert: (listaItensCard size = 3).
	self assert: ( (listaItensCard at:1) = sucoDeLaranja).
	self assert: ( (listaItensCard at:2) = lanche).
	self assert: ( (listaItensCard at:3) = xSalada).
	
	pedido removePrato: lanche.
	listaItensCard := pedido listaDePratos.
	self deny: (listaItensCard size = 3).
	self assert: (listaItensCard size = 2).
	self assert: ( (listaItensCard at:1) = sucoDeLaranja).
	self assert: ( (listaItensCard at:2) = xSalada).
! !

!PedidoTest methodsFor: 'as yet unclassified' stamp: 'ual 5/6/2007 13:05'!
testUmCliente	
	| clienteLocal clienteLocal2 |
	clienteLocal := 'Pica-Pau'.
	clienteLocal2 := 'Pernalonga'.
	meuPedido umCliente: clienteLocal.
	self assert: (meuPedido getNomeCliente = clienteLocal).
	meuPedido umCliente: clienteLocal2.
	self deny: (meuPedido getNomeCliente = clienteLocal).
	self assert: (meuPedido getNomeCliente = clienteLocal2).
! !


TestCase subclass: #PratoTest
	instanceVariableNames: 'xBurguer pao queijo carne tomate cebola'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fase2-Tests'!

!PratoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:42'!
setUp
	"cria prato xBurguer, feito de pao queijo e carne e custando 10 reais"

	| listaIngredientes |
	pao := Ingrediente novo:'Pao' precoDe:1 comCalorias:40.
	queijo := Ingrediente novo:'Queijo' precoDe:3 comCalorias:65.
	carne := Ingrediente novo:'Carne' precoDe:5 comCalorias:92.
	tomate:= Ingrediente novo:'Tomate' precoDe:1.15 comCalorias:15.
	cebola:= Ingrediente novo:'Cebola' precoDe:0.75 comCalorias:10.
	
	listaIngredientes := OrderedCollection new.
	listaIngredientes add:pao; add:queijo; add:carne.
	xBurguer := 
Prato novo: 'XBurguer' comPreco:10 feitoDe: listaIngredientes.
! !

!PratoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:43'!
testAddIngrediente
	
	| listaIngredientes |
	xBurguer addIngrediente: tomate.
	listaIngredientes := xBurguer ingredientes.
	
	self deny: (listaIngredientes size = 3).
	self assert: (listaIngredientes size = 4).
	
	self assert: ( (listaIngredientes at:1) = pao).
	self assert: ( (listaIngredientes at:2) = queijo).
	self assert: ( (listaIngredientes at:3) = carne).
	self assert: ( (listaIngredientes at:4) = tomate).
! !

!PratoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:43'!
testAtualizaCalorias
	
	| caloriasAntigas caloriasNovas |
	caloriasAntigas:= xBurguer calorias.
	xBurguer addIngrediente: tomate.
	xBurguer AtualizaCalorias.
	caloriasNovas:= xBurguer calorias.
	self deny: (caloriasNovas = caloriasAntigas).
	self assert: (caloriasNovas = (caloriasAntigas + tomate calorias) ).
! !

!PratoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:43'!
testGetCalorias
	
	| caloriasAntigas caloriasNovas |
	caloriasAntigas:= xBurguer calorias.
	xBurguer addIngrediente: tomate.
	caloriasNovas:= xBurguer getCalorias.
	self deny: (caloriasNovas = caloriasAntigas).
	self assert: (caloriasNovas = (caloriasAntigas + tomate calorias) ).
! !

!PratoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:43'!
testGetPreco
	
	self assert: (xBurguer getPreco = 9).
	xBurguer addIngrediente:tomate.
	self deny: (xBurguer getPreco = 9).
	self assert: (xBurguer getPreco = (9 + tomate preco) ).
! !

!PratoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:44'!
testIngredientes
	| listaIngredientes |
	listaIngredientes := xBurguer ingredientes.
	self assert: (listaIngredientes size = 3).
	
	self assert: ( (listaIngredientes at:1) = pao).
	self assert: ( (listaIngredientes at:2) = queijo).
	self assert: ( (listaIngredientes at:3) = carne).
! !

!PratoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:44'!
testNome

	self assert: (xBurguer nome = 'XBurguer').
	xBurguer nome: 'Sandubao'.
	self deny: (xBurguer nome = 'XBurguer').
	self assert: (xBurguer nome = 'Sandubao').
! !

!PratoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 15:20'!
testPreco
	"testa o metodo preco"
	
	self assert: (xBurguer preco = 10).
	xBurguer preco:42.
	self deny: (xBurguer preco = 10).
	self assert: (xBurguer preco = 42).
! !

!PratoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 15:39'!
testPrecoEmCentavos
	"testa o metodo preco"
	
	self assert: (xBurguer precoEmCentavos = 1000).
	xBurguer preco:17.
	self deny: (xBurguer precoEmCentavos = 1000).
	self assert: (xBurguer precoEmCentavos = 1700).
! !

!PratoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:45'!
testRemoveIngrediente
	
	| listaIngredientes |
	xBurguer removeIngrediente: queijo.
	listaIngredientes := xBurguer ingredientes.
	
	self deny: (listaIngredientes size = 3).
	self assert: (listaIngredientes size = 2).
	
	self assert: ( (listaIngredientes at:1) = pao).
	self deny: ( (listaIngredientes at:2) = queijo).
	self assert: ( (listaIngredientes at:2) = carne).
! !

!PratoTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:45'!
testSetListaIngredientes
	
	| listaIngredientes |
	listaIngredientes:= OrderedCollection new.
	listaIngredientes add:tomate; add:carne; add:cebola; add:pao.
	xBurguer setListaIngredientes: listaIngredientes.
	
	listaIngredientes := xBurguer ingredientes.
	self deny: (listaIngredientes size = 3).
	self assert: (listaIngredientes size = 4).
	
	self deny: ( (listaIngredientes at:1) = pao).
	self deny: ( (listaIngredientes at:2) = queijo).
	self deny: ( (listaIngredientes at:3) = carne).
	
	self assert: ( (listaIngredientes at:1) = tomate).
	self assert: ( (listaIngredientes at:2) = carne).
	self assert: ( (listaIngredientes at:3) = cebola).
	self assert: ( (listaIngredientes at:4) = pao).
! !


TestCase subclass: #RegistroTest
	instanceVariableNames: 'reg desconto ano mes numero validade'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fase2-Tests'!

!RegistroTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 21:16'!
setUp
	"seta reg"
	
	desconto:=1.
	numero:=12345678900.
	mes:=8.
	ano:=2009.
	reg:= Registro numero:numero mes:mes ano:ano desconto:desconto.
	validade:= reg getValidade.
! !

!RegistroTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 16:07'!
testGetDesc
	
	self assert: ( reg getDesc = desconto).
! !

!RegistroTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 16:08'!
testGetIndexAno
	
	self assert: ( reg getIndexAno = ano).
! !

!RegistroTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 16:08'!
testGetIndexMes
	
	self assert: ( reg getIndexMes = mes).
! !

!RegistroTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 16:08'!
testGetNumero
	
	self assert: ( reg getNumero = numero).
! !

!RegistroTest methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:48'!
testGetValidade
	
	| val |
	reg setAno: 1915.
	val:= reg getValidade.
	self deny: ( val = true).
	self assert: ( val = false).
! !

!RegistroTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 16:15'!
testSetAno
	
	| anoNovo |
	anoNovo:= 2100.
	reg setAno: anoNovo.
	self deny: ( reg getIndexAno = ano).
	self assert: ( reg getIndexAno = anoNovo).
! !

!RegistroTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 16:18'!
testSetDesc
	
	| descNovo |
	descNovo:= 0.05.
	reg setDesc: descNovo.
	self deny: ( reg getDesc = desconto).
	self assert: ( reg getDesc = descNovo).
! !

!RegistroTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 16:16'!
testSetMes
	
	| mesNovo |
	mesNovo:= 10.
	reg setMes: mesNovo.
	self deny: ( reg getIndexMes = mes).
	self assert: ( reg getIndexMes = mesNovo).
! !

!RegistroTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 16:14'!
testSetNumero
	
	| numNovo |
	numNovo:= 98765432100.
	reg setNumero: numNovo.
	self deny: ( reg getNumero = numero).
	self assert: ( reg getNumero = numNovo).
! !

!RegistroTest methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 21:18'!
testSetValidade
	
	| valNova |
	valNova:= false.
	reg setValidade: valNova.
	self deny: ( reg getDesc = validade).
"	self assert: ( reg getDesc = valNova). "
! !
