﻿Object subclass: #Cardapio
	instanceVariableNames: 'listaDePratos listaDeCombinados listaDeCombinadosDesativados'
	classVariableNames: 'Ocardapio'
	poolDictionaries: ''
	category: 'Fase2'!

!Cardapio methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 00:39'!
adicionaCombinado: umCombinado
	"adiciona um combinado, inicialmente desativado, ao cardápio"
	
	listaDeCombinadosDesativados 
add: umCombinado.
! !

!Cardapio methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 00:29'!
adicionaPrato: umPrato

	"adiciona um prato ao cardápio"
	
	listaDePratos 
add: umPrato.

! !

!Cardapio methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 00:38'!
ativa: umCombinado
	"torna um combinado visivel no cardápio que aparece na interface para clientes"
	
	listaDeCombinados 
add: umCombinado.
	listaDeCombinadosDesativados remove: umCombinado.
! !

!Cardapio methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 00:38'!
desativa: umCombinado
	"remove um combinado do cardápio que aparece para os clientes"
	
	listaDeCombinadosDesativados add: umCombinado.
	listaDeCombinados 
remove: umCombinado.
! !

!Cardapio methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 00:33'!
listaDeCombinados
	"Retorna a lista de todos os combinados ativados do cardapio"
	
	listaDeCombinados isNil ifTrue:[
		listaDeCombinados := OrderedCollection new.
	].
	
	^ listaDeCombinados.
! !

!Cardapio methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 00:41'!
listaDeCombinadosDesativados
	"Retorna a lista de todos os combinados desativados do cardapio"

	(listaDeCombinadosDesativados isNil)
	ifTrue:[
		listaDeCombinadosDesativados := OrderedCollection new.
	].
	
	^ listaDeCombinadosDesativados.
! !

!Cardapio methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 00:41'!
listaDePratos
	"Retorna a lista de todos os pratos do cardapio"
	^listaDePratos.
! !

!Cardapio methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 00:41'!
removeCombinadoDesativado: umCombinado

	"Remove um combinado do cardápio"
	
	listaDeCombinadosDesativados 
removeAllSuchThat: [:p | p = umCombinado].
	
! !

!Cardapio methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 00:42'!
removeCombinado: umCombinado

	"Remove um combinado do cardápio"
	
	listaDeCombinados 
removeAllSuchThat: [:p | p = umCombinado].

! !

!Cardapio methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 00:42'!
removePrato: umPrato

	"Remove um prato do cardápio"
	
	listaDePratos 
removeAllSuchThat: [:p | p = umPrato].
! !


!Cardapio methodsFor: 'as yet 
unclassified' stamp: 'ual 6/11/2007 00:33'!
iniciaLista

	"constroi as 
listas de pratos, combinados ativados e combinados desativados do cardapio, ainda vazias"


	
	(listaDePratos isNil)
	ifTrue:[
	listaDePratos:= 
OrderedCollection new.

].
	
	(listaDeCombinados isNil)
	ifTrue:[
	listaDeCombinados:= 
OrderedCollection new.

].
	
	(listaDeCombinadosDesativados isNil)
	ifTrue:[
	listaDeCombinadosDesativados:= 
OrderedCollection new.

].
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Cardapio class
	instanceVariableNames: ''!

!Cardapio class methodsFor: 'as yet unclassified' stamp: 'idl 6/9/2007 22:34'!
getInstance
	"Implementaçao do singleton"

     (Ocardapio = nil)
	ifTrue: [Ocardapio := Cardapio new. 
			Ocardapio iniciaLista.].
	^ Ocardapio
! !

!Cardapio class methodsFor: 'as yet unclassified' stamp: 'idl 6/9/2007 22:34'!
resetInstance

	"reseta a instancia."

  Ocardapio := Cardapio new.
	Ocardapio iniciaLista.
  ^ Ocardapio.! !


Object subclass: #CardapioIngredientes
	instanceVariableNames: 'listaDeIngredientes'
	classVariableNames: 'Ocardapio'
	poolDictionaries: ''
	category: 'Fase2'!

!CardapioIngredientes methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 17:28'!
adiciona: umIngrediente
	"adiciona um ingrediente ao cardápio de ingredientes"
	
	listaDeIngredientes 
add: umIngrediente.
! !

!CardapioIngredientes methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 18:03'!
listaDeIngredientes
	"Retorna a lista de todos os pratos do cardapio"
	
	^ listaDeIngredientes.
! !

!CardapioIngredientes methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 00:44'!
remove: umIngrediente
	"Remove um prato do cardápio"
	
	listaDeIngredientes 
removeAllSuchThat: [:p | p = umIngrediente].
! !


!CardapioIngredientes methodsFor: 'as yet 
unclassified' stamp: 'ual 6/11/2007 00:43'!
iniciaLista
	"constroi a 
lista de pratos do cardapio, ainda vazia"
	
	(listaDeIngredientes isNil)
	ifTrue:[
		listaDeIngredientes:= 
OrderedCollection new.
	].
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

CardapioIngredientes class
	instanceVariableNames: ''!

!CardapioIngredientes class methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 18:15'!
getInstance
	"Implementaçao do singleton"
	
	(Ocardapio = nil)
	ifTrue: [
		Ocardapio := CardapioIngredientes new.
		Ocardapio iniciaLista.
	].
	^ Ocardapio.
! !

!CardapioIngredientes class methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 18:14'!
resetInstance
	"reseta a instancia."
	
	Ocardapio := CardapioIngredientes new.
	Ocardapio iniciaLista.
	^ Ocardapio.! !


Object subclass: #GeradoraDeCupom
	instanceVariableNames: 'listaDeCodigos'
	classVariableNames: 'Instancia'
	poolDictionaries: ''
	category: 'Fase2'!

!GeradoraDeCupom methodsFor: 'as yet unclassified' stamp: 'idl 6/13/2007 22:40'!
consultaDesconto: umCPF
	"consulta se o cliente possui um desconto valido e retorna o valor de desconto, Caso o cliente nao possua direito ao desconto, ela retorna zero"
	
	| cont registro desconto |
	desconto := 0.
	(umCPF isNil)
	ifTrue:[
		^ 0.
	].
	(listaDeCodigos isNil)
	ifTrue:[
		listaDeCodigos:= OrderedCollection new.
	].

	cont := 1.
	[listaDeCodigos size >= cont]
	whileTrue:[
		registro := listaDeCodigos at:cont.
		
		(registro getNumero = umCPF)
		ifTrue:[
			(registro getValidade = true )
			ifTrue:[
				desconto := registro getDesc.
				listaDeCodigos remove: registro.
				registro setValidade:false.
				listaDeCodigos add: registro.
			].
		].
		cont := cont +1.
	].
	^ ((desconto asFloat) *0.01).
! !

!GeradoraDeCupom methodsFor: 'as yet unclassified' stamp: 'idl 6/13/2007 22:56'!
desconto: umValor
	"Esta funçao calcula o desconto do cliente"
	
	| descontoDe |
	descontoDe := 0.
	
	(umValor > 25)
	ifTrue:[descontoDe := 10]
	ifFalse:[
		(umValor > 14)
		ifTrue:[ descontoDe := 5].
	].
	^ descontoDe.
! !

!GeradoraDeCupom methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 16:36'!
geraRegistroDesc: umCPF valor: umValorConta
	"Gera um codigo de desconto."
	
	| mesIndex anoIndex registro valorMinimoParaDesconto desc |
	
	desc := self desconto: umValorConta.
	(listaDeCodigos isNil)
	ifTrue:[
		listaDeCodigos:= OrderedCollection new.
	].
	
	valorMinimoParaDesconto := 15.
	(umValorConta >= valorMinimoParaDesconto)
	ifTrue:[
		mesIndex := Date today monthIndex.
		anoIndex := Date today year.
		
		(mesIndex = 12)
		ifTrue:[
			mesIndex := 1.
			anoIndex := anoIndex +1.
		].
		registro := Registro numero: umCPF mes: mesIndex ano: anoIndex desconto:desc.
		listaDeCodigos add: registro.
	].
	^ desc.
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

GeradoraDeCupom class
	instanceVariableNames: ''!

!GeradoraDeCupom class methodsFor: 'as yet unclassified' stamp: 'idl 6/10/2007 00:30'!
getInstance
	"Inicializacao"
	
	Instancia isNil 
	ifTrue:[
		Instancia := GeradoraDeCupom new.
		].

^Instancia.! !

!GeradoraDeCupom class methodsFor: 'as yet unclassified' stamp: 'idl 6/10/2007 01:51'!
resetInstance "Inicializacao"
	
	Instancia := GeradoraDeCupom new.
	

	^Instancia.! !


Object subclass: #Ingrediente
	instanceVariableNames: 'calorias preco nome'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fase2'!

!Ingrediente methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:03'!
calorias
	"Retorna calorias do ingrediente"
	^ calorias.
! !

!Ingrediente methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:03'!
calorias: variasCalorias
	"Define as calorias"
	
	calorias := variasCalorias.
! !

!Ingrediente methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:03'!
getCalorias
	"Retorna calorias do ingrediente"
	^ calorias.
! !

!Ingrediente methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:04'!
getNome
	"retorna nome"
	^ nome.
! !

!Ingrediente methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:04'!
getPreco
	"Retorna preco."
	^ preco.
! !

!Ingrediente methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:05'!
getPrecoIngrediente
	"Retorna preco."
	^ preco.
! !

!Ingrediente methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:05'!
nome
	"retorna nome"
	^ nome.
! !

!Ingrediente methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:06'!
nome: umNome
	"Define nome do ingrediente"
	
	nome := umNome.
! !

!Ingrediente methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:06'!
preco
	"retorna preco"
	^ preco.
! !

!Ingrediente methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:06'!
preco:umPreco
	"Define preco"
	
	preco:= umPreco.
! !

!Ingrediente methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:07'!
setCalorias: variasCalorias
	"Define as calorias"
	
	calorias:= variasCalorias.
! !

!Ingrediente methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:07'!
setNome: umNome
	"Define nome do ingrediente"
	
	nome := umNome.
! !

!Ingrediente methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:07'!
setPreco:umPreco
	"Define preco"
	
	preco:= umPreco.
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Ingrediente class
	instanceVariableNames: ''!

!Ingrediente class methodsFor: 'as yet unclassified' stamp: 'idl 6/9/2007 22:11'!
novo: umNome precoDe: umPreco comCalorias: variasCalorias

	"Inicializa o ingrediente"

	
	
	| ingrediente |

	ingrediente := Ingrediente new. 
	ingrediente nome: umNome. 
	ingrediente preco: umPreco.
	ingrediente calorias: variasCalorias.
	^ ingrediente.

									
! !


Object subclass: #ItemDoCardapio
	instanceVariableNames: 'nome preco calorias'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fase2'!

!ItemDoCardapio methodsFor: 'as yet unclassified' stamp: 'idl 6/9/2007 22:03'!
calorias
	"retorna o total de calorias"
	self subclassResponsibility.
! !

!ItemDoCardapio methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:10'!
nome
	"retorna o nome"
	^nome.
! !

!ItemDoCardapio methodsFor: 'as yet unclassified' stamp: 'idl 6/9/2007 22:04'!
nome: umNome
	
	"Define o 
nome do item"

	

	nome:= umNome.
! !

!ItemDoCardapio methodsFor: 'as yet unclassified' stamp: 'idl 6/9/2007 22:04'!
preco
	"retorna o preco"
	self subclassResponsibility.
! !

!ItemDoCardapio methodsFor: 'as yet unclassified' stamp: 'idl 6/12/2007 12:05'!
prepareSe
	self subclassResponsibility.
! !


ItemDoCardapio subclass: #Combinado
	instanceVariableNames: 'listaDePratos ativado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fase2'!

!Combinado methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 00:46'!
AtualizaCalorias
	calorias := self getCalorias.
! !

!Combinado methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 00:46'!
addPrato: umPrato
	"Adiciona um prato à lista de pratos do combinado."
	
	listaDePratos = nil ifTrue:[
		listaDePratos := OrderedCollection new.].
	listaDePratos add: umPrato.
! !

!Combinado methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 00:46'!
ativado
	"retorna o valor de ativado, informando assim se a instância de combinado está ativada ou não no cardápio"
	
	^ativado.
! !

!Combinado methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 00:47'!
ativar
	"ativa o combinado, de modo que ele apareça no cardápio"
	
	ativado:=true.
! !

!Combinado methodsFor: 'as yet unclassified' stamp: 'idl 6/9/2007 22:19'!
calorias
	"retorna valor calórico do combinado"
	calorias = nil ifTrue:[
		calorias := self getCalorias.
	].
	^calorias.
! !

!Combinado methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 00:47'!
desativar
	"desativa o combinado, de modo que ele não apareça no cardápio"
	
	ativado:=false.
! !

!Combinado methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 00:48'!
getCalorias
	"calcula o valor calórico do combinado"
	
	| cont pratoAtual acrescimo total |
	total :=0.
	listaDePratos = nil ifTrue:[
		listaDePratos:= OrderedCollection new.
	].
	(listaDePratos size > 0)
	ifTrue:[
	cont:= 1.
	[listaDePratos size >= cont]
	whileTrue:[ pratoAtual := listaDePratos at: cont.
		acrescimo := pratoAtual calorias.
		total := total + acrescimo.
		cont := cont +1.].
	].
	^ total.
! !

!Combinado methodsFor: 'as yet unclassified' stamp: 'idl 6/13/2007 23:16'!
getPreco
	"retorna soma de preços individuais dos pratos pertencentes ao combinado"
	
	| precoSomado cont pratoAtual acrescimo |
	
	
	precoSomado :=0.
	(listaDePratos size > 0)
	ifTrue:[
		cont:= 1.
		[listaDePratos size >= cont]
		whileTrue:[	pratoAtual := listaDePratos at: cont.
			acrescimo := pratoAtual preco.
			precoSomado := precoSomado + acrescimo.
			cont := cont +1.
		].
	].


	^precoSomado.
! !

!Combinado methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 00:50'!
listaDePratos: umaLista
	"seta lista de pratos do combinado"
	
	listaDePratos:= umaLista.
! !

!Combinado methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 00:50'!
pratos
	"retorna a lista de pratos"
	
	^ listaDePratos.
! !

!Combinado methodsFor: 'as yet unclassified' stamp: 'idl 6/13/2007 23:18'!
preco
	"retorna preço do combinado"
	preco isNil
	ifTrue:[preco:= self getPreco.].
	^preco.
! !

!Combinado methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 00:50'!
preco: umValor
	"seta preço do combinado"
	
	preco:=umValor.
! !

!Combinado methodsFor: 'as yet unclassified' stamp: 'idl 6/12/2007 12:19'!
prepareSe
	|cont|
	cont:=1.
	[listaDePratos size > cont ]whileTrue:[
		(listaDePratos at: cont )prepareSe.
		cont := cont+1.
	].
	
	! !

!Combinado methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 00:51'!
removePrato: umPrato
	"Retira um prato da lista de pratos do combinado."
	
	listaDePratos remove: umPrato.
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Combinado class
	instanceVariableNames: ''!

!Combinado class methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 17:19'!
novo: umNome comPreco: umValor
	"Cria um combinado novo de nome umNome e cujo preço é umValor. Por default, o combinado é criado desativado."
	
	| combinadoNovo |
	combinadoNovo := Combinado new.
	combinadoNovo
		nome: umNome;
		preco: umValor;
		getCalorias;
		desativar.
	^combinadoNovo.
! !

!Combinado class methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 17:20'!
novo: umNome compostoDe: umaListaDePratos
	"Cria um combinado novo de nome umNome que contém os pratos encontrados em umaListaDePratos. O valor calórico eh determinado a partir da lista de pratos fornecida. O preço ainda precisará ser determinado posteriormente. Por default, o combinado é criado desativado."
	
	| combinadoNovo |
	combinadoNovo := Combinado new.
	combinadoNovo
		setNome: umNome;
		listaDePratos: umaListaDePratos;
		desativar.
	^combinadoNovo.
! !

!Combinado class methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 17:20'!
novo: umNome compostoDe: umaListaDePratos comPreco: umValor
	"Cria um combinado novo de nome umNome que contém os pratos encontrados em umaListaDePratos e cujo preço é umValor. O valor calórico eh determinado a partir da lista de pratos fornecida. Por default, o combinado é criado desativado."
	
	| combinadoNovo |
	combinadoNovo := Combinado new.
	combinadoNovo
		nome: umNome;
		listaDePratos: umaListaDePratos;
		preco: umValor;
		desativar.
	^combinadoNovo.
! !


Object subclass: #Pedido
	instanceVariableNames: 'dinheiroRecebido listaDePratos umCliente desconto maxCalorias cpf'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fase2'!

!Pedido methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:13'!
adiciona: umPrato
	"Adiciona pratos ao pedido."
	
	(listaDePratos = nil)
	ifTrue: [ listaDePratos:= OrderedCollection new.].
	
	listaDePratos add: umPrato.
! !

!Pedido methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:13'!
cpf
	^ cpf.
! !

!Pedido methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:14'!
cpf: umValor
	cpf:= umValor.
! !

!Pedido methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:14'!
desconto
	^ desconto.
! !

!Pedido methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:14'!
desconto: umValor
	desconto:= umValor.
! !

!Pedido methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:14'!
fecharPedido: umValor
	"Retorna o valor do troco"
	
	| troco preco 
|

	preco := self precoAtual.
	troco := umValor - preco.

	^troco.
! !

!Pedido methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 05:42'!
getCalorias
	"Retorna as calorias"
	
	| cont prato caloriaPrato caloriaTotal |
	caloriaTotal :=0.
	(listaDePratos size > 0)
	ifTrue:[
		cont:= 1.
		[listaDePratos size >= cont]
		whileTrue:[
			prato := listaDePratos at: cont.
			caloriaPrato := prato calorias.
			caloriaTotal := caloriaTotal + caloriaPrato.
			cont := cont+1.
		].
	].
	^ caloriaTotal.
! !

!Pedido methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:17'!
getNomeCliente


	"Retorna o nome do cliente ou a mesa"
	^ 
umCliente.
! !

!Pedido methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:18'!
limparPedido
	"Se o 
cliente pagou, remover todos os itens do pedido."
	
	listaDePratos reset.

! !

!Pedido methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:18'!
listaDePratos
	"Retorna a lista de pratos no pedido"
	^listaDePratos.
! !

!Pedido methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:22'!
maxCalorias
	^ maxCalorias.
! !

!Pedido methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:22'!
maxCalorias: umValor
	maxCalorias:= umValor.
! !

!Pedido methodsFor: 'as yet unclassified' stamp: 'idl 6/13/2007 23:20'!
precoAtual

	"Retorna o preço atual do pedido"


	
	| cont preco |
	cont := 1.
	preco := 0.
	
	[listaDePratos size >= cont]
	whileTrue:[
		preco := preco + (listaDePratos at: cont) preco.
		cont 
:= cont +1.
	].
	
	^ preco.
! !

!Pedido methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:25'!
setCliente: nomeCliente
	"Nome do cliente ou mesa do 
pedido."
	
	umCliente := nomeCliente.
! !

!Pedido methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:26'!
showPrecoAtual
	"Mostra o preço atual"

	| preco |
	preco 
:= self precoAtual.
	Transcript
	show:'';	cr;
	show:'O preço atual é ';
	show: preco; show:'.' ; cr.
! !

!Pedido methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:27'!
umCliente: nomeCliente
	"Nome do cliente ou mesa do 
pedido."

	umCliente := nomeCliente.
! !


!Pedido methodsFor: 'as yet 
unclassified' stamp: 'ual 6/11/2007 01:21'!
listarItens
	"Imprime nome e 
preço de todos os pratos do pedido"

	| cont  pratoAtual |
	(listaDePratos 
= nil  | listaDePratos size == 0)
	
	ifTrue:[	Transcript show: '';cr; show:'Não há pratos 
cadastrados neste pedido'; cr;cr.]
	ifFalse:[Transcript show: '';cr; show: 
'Iten(s) de seu pedido.:'; cr. ].

	cont := 1.
	[listaDePratos size >= 
cont]
	whileTrue:[
		pratoAtual := listaDePratos at: cont.
		Transcript 
show: '';cr.
		Transcript show: 
'============================================'; cr.
		Transcript
			show: 
'Prato: ' ;  show: pratoAtual getNome; cr;
			show: 'Preço: ' ;  
show: pratoAtual getPreco;cr;
			show: 'Ingredientes: ';cr;
			show: pratoAtual showIngredientes ;cr;cr.
		cont := cont+1.
	].
	(listaDePratos size > 0)
	ifTrue:[self 
showPrecoAtual.].
! !

!Pedido methodsFor: 'as yet 
unclassified' stamp: 'ual 6/11/2007 01:24'!
removePrato: umPrato
	"Remove 
prato da lista"
	
	listaDePratos remove: umPrato.
! !


ItemDoCardapio subclass: #Prato
	instanceVariableNames: 'ingredientes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fase2'!

!Prato methodsFor: 'as yet unclassified' stamp: 'idl 6/8/2007 05:59'!
AtualizaCalorias
	calorias := self getCalorias.
! !

!Prato methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:30'!
addIngrediente: umIngrediente
	"seta os 
ingredientes do prato"

	(ingredientes = nil)
	ifTrue:[
		ingredientes:= OrderedCollection new.].
	ingredientes add: umIngrediente.
! !

!Prato methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:31'!
calorias
	(calorias = nil)
	ifTrue:[
		calorias:= self getCalorias.].
	^ calorias.
! !

!Prato methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:33'!
getCalorias
	"Retorna as calorias"
	
	| cont ingrediente caloriaIngrediente caloriaTotal |
	caloriaTotal :=0.
	(ingredientes size > 0)
	ifTrue:[
		cont:= 1.
		[ingredientes size >= cont]
		whileTrue:[
			ingrediente := ingredientes at: cont.
			caloriaIngrediente := ingrediente getCalorias.
			caloriaTotal := caloriaTotal + caloriaIngrediente.
			cont := cont+1.
		].
	].
	^ caloriaTotal.
! !

!Prato methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 14:41'!
getIngredientes

	"Retorna os ingredientes"
	^ ingredientes.
! !

!Prato methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:34'!
getListaIngredientes
	"Retorna os ingredientes"
	^ ingredientes.
! !

!Prato methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:34'!
getNome
	"Retorna o nome do prato"
	^ nome.
! !

!Prato methodsFor: 'as yet unclassified' stamp: 'idl 6/13/2007 23:16'!
getPreco
	"Retorna o 
preço do prato"
	
	| cont  ingrediente precoIngrediente precoTotal |
	
	
	precoTotal :=0.
	(ingredientes size > 0)
	ifTrue:[
		cont:= 1.
		[ingredientes size >= cont]
		whileTrue:[
			ingrediente := ingredientes at: cont.
			precoIngrediente := ingrediente getPrecoIngrediente.
			precoTotal := precoTotal + precoIngrediente.
			cont := cont +1.
		].
	].


	^ precoTotal.
! !

!Prato methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:38'!
ingredientes
	"Retorna os ingredientes"
	^ ingredientes.
! !

!Prato methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:39'!
ingredientes: umaLista
	"seta os 
ingredientes do prato"

	ingredientes:= umaLista.
! !

!Prato methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:39'!
nome
	"Retorna o nome do prato"
	^ nome.
! !

!Prato methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:39'!
nome: umNome
	"seta o 
nome do prato"
	nome:= umNome.
! !

!Prato methodsFor: 'as yet unclassified' stamp: 'idl 6/13/2007 23:18'!
preco
	"Retorna o 
preço do prato"
	preco isNil
	ifTrue:[preco:= self getPreco.].
	^ preco.
! !

!Prato methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:40'!
precoEmCentavos

	|cents|
	cents:= preco.
	cents:= cents*100.
	cents:= cents asInteger.
	^ cents.
! !

!Prato methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:40'!
preco: umPreco

	"seta o preço do 
prato"
	preco:= umPreco.
! !

!Prato methodsFor: 'as yet unclassified' stamp: 'idl 6/12/2007 12:08'!
prepareSe
	|cont robo|
	cont:=1.
	robo := Robo getInstance.
	[ingredientes size > cont ]whileTrue:[
		robo prepara: (ingredientes at: cont).
		cont := cont+1.
	
	].
	robo juntaPrato: nome.
	! !

!Prato methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:40'!
removeIngrediente: umIngrediente
	ingredientes remove: umIngrediente.
! !

!Prato methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:40'!
remove: umIngrediente
	ingredientes remove: umIngrediente.
! !

!Prato methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:41'!
setIngrediente: umIngrediente
	"seta os 
ingredientes do prato"
	
	ingredientes add: umIngrediente.
! !

!Prato methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:41'!
setListaIngredientes: umaLista
	"seta os 
ingredientes do prato"
	
	ingredientes:= umaLista.
! !

!Prato methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:41'!
setNome: umNome
	"Define o 
nome do prato"
	
	nome:= umNome.
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Prato class
	instanceVariableNames: ''!

!Prato class methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 14:18'!
novo:  
umNome comPreco: umValor feitoDe: umaLista

	"construtor da classe e 
inicializador das variaveis"
	| PratoNovo |
	PratoNovo := Prato 
new.

	PratoNovo nome: umNome.
	PratoNovo preco: umValor.
	PratoNovo 
ingredientes: umaLista.


	^ PratoNovo.



! !

!Prato class methodsFor: 'as yet unclassified' stamp: 'edubmac 6/7/2007 21:47'!
novo:  
umNome feitoDe: umaLista
	

	"construtor da classe e 
inicializador das variaveis"

	

	| PratoNovo |
	

	PratoNovo := Prato 
new.
	PratoNovo setNome: umNome.
	PratoNovo setListaIngredientes: umaLista.

	

	^ PratoNovo.! !


Object subclass: #Registro
	instanceVariableNames: 'desconto ano mes numero validade'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fase2'!

!Registro methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 15:44'!
getDesc
	"retorna o desconto."
	^desconto.
! !

!Registro methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 15:44'!
getIndexAno
	"retorna o valor do ano"
	^ ano.
! !

!Registro methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:46'!
getIndexMes
	
	^mes.
! !

!Registro methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:46'!
getNumero
	"retorna valor de cpf"
	^numero.
! !

!Registro methodsFor: 'as yet unclassified' stamp: 'idl 6/13/2007 22:48'!
getValidade
	"retorna se o desconto ainda eh valido"
	
	| quantMesesValidos |
	validade isNil
	ifTrue:[
	validade := false.
	
	quantMesesValidos := 1.
	(self getIndexAno = Date today year)
	ifTrue:[
		((self getIndexMes + quantMesesValidos ) >= Date today monthIndex)
		ifTrue:[
			validade := true.].].].
	^ validade.
! !

!Registro methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:46'!
setAno: umValor
	"Define o indixe do ano"
	
	ano := umValor.
! !

!Registro methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:47'!
setDesc: umValor
	"define a quantidade de desc."
	
	desconto := umValor.
! !

!Registro methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 15:46'!
setMes: umValor
	"Define o index do mes"
	
	mes := umValor.
! !

!Registro methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:47'!
setNumero: umValor
	"define o CPF"
	
	numero := umValor.
! !

!Registro methodsFor: 'as yet unclassified' stamp: 'ual 6/10/2007 15:46'!
setValidade: umValor
	"define a validade"
	
	validade:= umValor.
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Registro class
	instanceVariableNames: ''!

!Registro class methodsFor: 'as yet unclassified' stamp: 'idl 6/13/2007 22:41'!
numero: umCPF mes: umMes ano: umAno desconto: umDesconto
"construtor da classe e 
inicializador das variaveis"

	| registro |
	registro:= Registro new.
	registro setNumero: umCPF;
			setMes:umMes;
			setAno:umAno;
			setDesc:umDesconto.

	^registro.
! !


Object subclass: #Robo
	instanceVariableNames: 'mensagens'
	classVariableNames: 'Orobo'
	poolDictionaries: ''
	category: 'Fase2'!

!Robo methodsFor: 'as yet unclassified' stamp: 'ual 6/11/2007 01:50'!
juntaPrato
	"Juntou o Prato."
	
	Transcript show: 'Juntou o 
prato e o pedido esta pronto'.
! !

!Robo methodsFor: 'as yet unclassified' stamp: 'idl 6/12/2007 12:05'!
juntaPrato: umNome
	"Juntou o Prato."
	
	mensagens = nil ifTrue:[
		mensagens := OrderedCollection new.
	].
	mensagens add: ('Juntei prato', umNome printString).
! !

!Robo methodsFor: 'as yet unclassified' stamp: 'idl 6/12/2007 12:06'!
mensagens
^ mensagens.! !

!Robo methodsFor: 'as yet unclassified' stamp: 'idl 6/12/2007 12:03'!
prepara: umIngrediente
	"Robo preparando o 
prato."
	
	mensagens = nil ifTrue:[
		mensagens := OrderedCollection new.
	].
	mensagens add: ('Preparei', umIngrediente nome printString).
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Robo class
	instanceVariableNames: ''!

!Robo class methodsFor: 'as yet unclassified' stamp: 'idl 6/12/2007 12:01'!
getInstance
	"Implementaçao do singleton"
	Orobo = nil
		ifTrue: [Orobo := Robo new.].
	^ Orobo.! !

!Robo class methodsFor: 'as yet unclassified' stamp: 'idl 6/12/2007 12:02'!
resetInstance
	"Implementaçao do singleton"
	Orobo := Robo new.
! !
